pro dek_lucy_msdp,obraz,szer,wynik,nk,warunek

;psf - jako gaussoida
;opis danych wej/wyj
;obraz - obraz wejsciowy
;szer - fwhm gausoidy - psf
;wynik - obraz po dekonwolucji
;nk - podzial na subpiksele 1:1 - 1, 1:3 - 3, 1:5 - 5
;warunek skonczenia iteracji - domyslnie chi2=0.9
if nk eq 1 or nk eq 3 or nk eq 5 then begin
goto, lab1
endif else begin
print, 'podzial tylko na subpiksele 1:1 - 1, 1:3 - 3, 1:5 - 5'
stop
endelse


lab1:

;psf=psf_gaussian(npixel=19,fwhm=[szer,szer],ndim=2,centroid=[9,9])

if n_elements(warunek) eq 0 then begin
warunek=0.9
endif

;*********************************************************************
;   image deconvolution
;
;   Marek Siarkowski 20.09.97
;   changes Robert Falewicz 22.10.98
;   ver. 1.1 z poprawionym tlem
;   10.12.98 uogolnienie wyswietlania przekroi z 64 na 128
;   19.01.99 usprawnienie wyswietlania systemu okien
;   29.11.2000 nowe podejscie + mozliwosc analizowania calych serii
;   09.05.2001 zmiana procedury w format programu i mozliwosci
;                    dekonwolucji 1:3 i 1:5
;   20.01.2014 przystosowanie procedury do obrazow MSDP
;*********************************************************************
;czytanie danych ze zbioru
;potrzebuje save z beindex,alindex,bedata,aldata
;naz='91dec10.dat'
;input,'Podaj nazwe pliku z danymi do dekonwolucji',naz,naz
;restore,naz,/verbose
;
;wynikbe=bedata
;wynikal=aldata
;
;mamy teraz bedata i aldata, alindex, beindex
;rozmiar i ilosc
siz=size(obraz)

print,'oryginalny rozmiar obrazu = ',siz(2)
print,'DEKONWOLUCJA 1:',nk
;ilosc=1
;rozm=64
;
;polozenie x i y
;ss=gt_center(beindex)
;xx=xx;average(ss(0,*))
;yy=yy;average(ss(1,*))
;print,'polozenie : x=',xx,' y=',yy
loadct,3
;
close,/all

;
;dane do dekonwolucji
;
;rozmiar obrazu
n=siz(2);rozm
; nk krok podzialu, n1=n*nk tablica z subpikselami
nk=nk
; a00 ew. wartosc minimalna
a00=5.9
; st wartosc dchi przy ktorej zatrzymujemy iteracje
st=0.001
; nkr liczba krokow iteracji
nkr=200
; np rozmiar tablicy PSF (1:1)
;psf_siz=size(psf)
;np=psf_siz(1)  ;np=9
np=19
; imn liczba obrazow
imn=1

n=fix(n) & nk=fix(nk) & nkr=fix(nkr)
np=fix(np) & imn=fix(imn)
;
; tworzymy tablice - a obserwowany
;		     b wyliczony
;		     ax objekt z subpikselami
;		     ay ax poszerzony o psf do 'gladszej' konwolucji
;
a=make_array(n,n)
b=make_array(n,n)
a1=make_array(n,n,imn)
agen=make_array(n,n,imn)
b1=a1
n1=n*nk
ax=make_array(n1,n1)
ax1=make_array(n1,n1,imn)
pm0=fix((np-1)/2)
pm01=pm0+n-1
ns=np*nk
pm=fix((ns-1)/2)
pm1=pm+n1-1
ay0=make_array(n+2*pm0,n+2*pm0)
ay=make_array(n1+2*pm,n1+2*pm)
c=ay
;
;tablica ograniczajaca dopasowanie PSF
;dopasoujemy sie tylko do tych pikseli dla ktorych funkcja
;PSF polozona nad tymi pixelami miejsci sie calkowicie w tablicy
;obserwowanej
;
ogr=a
ogr1=fltarr(n-np+1,n-np+1)
ogr1=ogr1*0+1.
ogr(pm0,pm0)=ogr1
;
; Funkcja PSF jest czytana lub zadana jako stala
;
;s0=fltarr(ns,ns)
window,0,xsize=1024,ysize=512

;**************************************************************************
psf=psf_gaussian(npixel=np*nk,fwhm=[szer*nk,szer*nk],ndim=2,centroid=[(np*nk)/2,(np*nk)/2],/normalize)
s0=psf
;s0=sxt_psfp(filtr,xx,yy,dim=7*nk,xnk=nk)
;al12->5, Be->4,xc,yc z gt_center,xnk=podzial czy 1:1 czy 1:3 wartosc:1 lub 3,5
;**************************************************************************
print,'Rozmiar tablicy PSF'
help,s0
print,'srodek PSF =',(np*nk)/2

;definicje okien


;window,2,xsize=512,ysize=512


;stop
;procedura wywolujaca PSF sxt
;s0=fltarr(15,15);tutaj wstawilem jako stala PSF
;s01=fltarr(ns,ns,imn)
;
;openr,1,'psf8'
;readf,1,s0
;close,1
;if nk eq 3 then s0=rebin(s0,45,45)
;
;s00=s00*0. + .1
;s00=s00/total(s00)
;stop,'psf1:3'
;
; aby procedura convol dzilala poprawnie musimy obrocic PSF o 180 stopni
;
s0=s0/total(s0)
s3=rotate(s0,2)
;
;tablica poprawek
;przy obliczamiu sumy (a/b)*psf liczymy wieloktotnie ten sam psf
;scentrowany nad roznymi subpikselami - wystarczy to jednak zrobic
;dla tablicy (nk,nk) i pozniej odpowiednio przesuwac
;jesli nasza tablice (nk,nk,n,n) policzymy dla srodkowego piksela
;(duzego) tablicy a (czyli piksela n0) to pozniej musimy uzyc przesuniecia
;i-n0,j-n0
;
n0=fix(n/2)
n10=n0*nk
cor=fltarr(nk,nk,n,n)
;
for i=0,nk-1 do begin
for j=0,nk-1 do begin
i1=i+n10
j1=j+n10
ax=ax*0.
ax(i1-pm,j1-pm)=s0
b=rebin(ax,n,n)*nk*nk
cor(i,j,*,*)=b
endfor
endfor
;
;czytamy dane zawierajace obrazy
;
;*************************************************************************
a=obraz

;openr,1,'91dec10_be.dat'
;************************************************************************

for k=0,imn-1 do begin
;readf,1,a
ag=a
;a=(a>0)+1.0
;if min(a) le -0.00000001 then a=a+abs(floor(a))+1
;if min(a) le 0.00000001 then a=(a>0)+0.000000001
a=(a>0)+0.000000001
a1(*,*,k)=a
agen(*,*,k)=ag
;stop
;
ax=ax*0+1
ax=congrid(a,n1,n1,/cubic,/minus_one)
ax=ax*total(a)/total(ax)
ax1(*,*,k)=ax
endfor
aro=ax1
close,1
;tvscl,ax1(*,*,0)
;tvscl,ax1(*,*,1),192,0
;
;otwieramy zbiory wynikowe   - h dopasowania
;			     - d wyniki (obrazy po dekonwolucji)
;			     - s funkcja PSF
;			     - b wartosci obserwowane i wyliczone
;
openw,2,'hh.1'
;openw,3,'s.1'
;openw,4,'d.1'
;openw,5,'b.1'
;
;	wlasciwa dekonwolucja
;
;	LC=0
	KL=0
	ROB=1.0E+06
	chi1=0.
	dchi=0.
;
;
;      W KOLEJNYM KROKU KL ROBIMY KONWOLUCJE I POROWNUJEMY A Z B
;      W SENSIE CHI KWADRAT
;	szersza tabhelp,a
;lice ay wypelmiamy tlem = sredniej z bokow obrazu
;
;stop;
lab12:
for kkk=0,imn-1 do begin
ax=ax1(*,*,kkk)
a=a1(*,*,kkk)
brzeg=(total(ax(*,0))+total(ax(0,*))+total(ax(n1-1,*))+total(ax(*,n1-1)))/(4*n1)
;stop
;fitrob,ax,ay
ay=ay*0+brzeg;	+(total(ax(*,0))+total(ax(0,*))+total(ax(n1-1,*))+total(ax(*,n1-1)))/(4*n1)
ay(pm,pm)=ax
C=CONVOL(ay,s3)
az1=C(pm:pm+n1-1,pm:pm+n1-1)
b=rebin(az1,n,n)*nk*nk
b1(*,*,kkk)=b
;stop
;
;dopasowania
;
aa=(a-b)
aa=aa*aa/a                   ;chikwadrat
chi=total(aa)/(n*n)
;
m01=a ge 0.3*max(a)
aa=(a - b)*m01
aa=aa*aa/a
chi1=total(aa)/total(m01)    ;chikwadrat dla fragmentow obrazu o duzym natezeniu
;
DCHI=ROB-CHI1
;
printf,2,kkk,kl,chi,chi1,max(ax);,max(s0)
openw,10,'wsk
printf,10,kkk,kl,chi,chi1,max(ax);,max(s0)
close,10
;,format='(2i4,2f11.5,f13.8,f11.1,f11.5)'
print,kkk,kl,'   chi=',chi,chi1,max(ax);,max(s0)		;,format='(2i4,3f10.5,f11.1,f11.5)'
;
if (kl eq nkr) then goto, lab30
;if (kl/50)*50 eq kl and (kl ne 0) then printf,4,ax	;zapisujemy wynik co 50-ty krok
;
;poprawianie obrazu
;
	cal=a/b                                                ;w starej wersji bylo kilka razy dluzej
	for K=0,N1-1 do begin                                  ;ay(k,l)=s0
	for L=0,N1-1 do begin                                  ;az1=ay(pm:pm1,pm:pm1)
	ay=ay*0.
	ay(k,l)=s0
	az1=ay(pm:pm1,pm:pm1)
        	cal1=rebin(az1,n,n)*nk*nk;*ax(k,l)
	;cal1=ay0(pm0:pm01,pm0:pm01)
	ww=total(cal1)
	ax(k,l)=ax(k,l)*total(cal*cal1)/ww
	endfor
	endfor
;
;normujemy i wyswietlamy kolejne przyblizenie
;
ax=ax*total(a)/total(ax)
izc=[.1,.2,.3,.4,.5,.6,.7,.8,.9,.95]*max(ax)


; WIZUALIZAJA DANYCH

;***********************************************************************
;wset,0
;ms_im_co,ax,izc
;wset,1
roz=512/(siz(2)*nk)
rrr=roz*siz(2)*nk
tvscl,congrid(aro(*,*,kkk),rrr,rrr),0,0


xyouts,5,5,'przed dekon.',charsize=1.2,/device
tvscl,rebin(ax1,rrr,rrr,/sample),512,0
xyouts,530,5,'po dekon. => '+strcompress(kl,/remove_all),charsize=1.2,/device

;wset,2
;!p.multi=[0,2,2]
;pd=a1(*,*,kkk)
;znacz=max(pd,zn)
;znacz2=max(pd(*,(zn/n)),zn2)
;plot,pd(*,(zn/n)),title='przed dekon. ciecie w X'
;plot,pd(zn2,*),title='przed dekon. ciecie w Y'


;znacz=max(ax,zn)
;znacz2=max(ax(*,(zn/n)),zn2)
;plot,ax(*,(zn/n)),title='ciecie w X'
;plot,ax(zn2,*),title='ciecie w Y'
;!p.multi=0
ax1(*,*,kkk)=ax
;save,filename='posred.bin',ax1
;********************************************
if chi1 lt warunek then goto, lab9 ;warunek wylaczenia dekonwolucji
;if dchi le 0.04 then goto,lab9 ;kiedy za slabo sie zbiega
lab500:
;***********************************************************************
;
;dopasowywanie psf
;
;uaktualniamy obraz policzony - b
;
lab30:

if kl eq nkr then goto, lab9		;koniec petli po obrazach
;
lab31:
;stop
;save, /all, filename='s1.dat'		;to na wypadek awarii i mozliwosci kontynuacji
;
	KL=KL+1
	ROB=CHI1
;if (kl/50)*50 eq kl then printf,3,s0
;
	GOTO, lab12
;
;
;      ZAPISUJEMY WYNIKI
;
lab9:

for kkk=0,imn-1 do begin
obr=splotim(ax1(*,*,kkk),s0,1)
print,'Blad
print,kkk,abs(100.-((max(obr)*100.)/max(agen(*,*,kkk)))),' %
;printf,4,ax1(*,*,kkk)
;printf,5,b1(*,*,kkk)
endfor
;printf,3,s0
close
robert1:
close,/all

;openw,1,'wynik.dat
;printf,1,ax1
;close,1
wynik=ax1

;save,filename='wynik.bin',ax1
;stop
endfor
;bnaz='wynik_'+naz
;save,filename=bnaz,wynikbe,wynikal

END
